=== debian/changelog ===
febug (0.1.1+dfsg-1) unstable; urgency=medium

  * Initial packaging, upstream version 0.1.1+dfsg
    (removed generated graphviz graph)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Tue, 08 Dec 2020 18:35:44 +0100
