=== debian/control ===
Source: febug
Section: debug
Priority: optional
Maintainer: наб <nabijaczleweli@nabijaczleweli.xyz>
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Git: https://git.sr.ht/~nabijaczleweli/febug.deb
Vcs-Browser: https://git.sr.ht/~nabijaczleweli/febug.deb
Homepage: https://sr.ht/~nabijaczleweli/febug
Build-Depends: debhelper,
               debhelper-compat (= 13),
               pkg-config,
               mandoc,
               graphviz,
               libfuse3-dev,

Package: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c++, interface::commandline, role::program, scope::utility
Description: Cooperative debugging filesystem, inspired by debugfs
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the FUSE-based driver.

Package: libfebug0
Recommends: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c, role::library
Description: Cooperative debugging filesystem, inspired by debugfs -- C library
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the run-time C library.

Package: libfebug-dev
Recommends: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c, role::library
Description: Cooperative debugging filesystem, inspired by debugfs -- C development files
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the development files and man-pages for the C library.

Package: libfebug++-dev
Recommends: febug
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Tag: implemented-in::c, role::library
Description: Cooperative debugging filesystem, inspired by debugfs -- C++ development files
 Applications can register variables to be observable,
 showing up as files in /var/run/febug/$PID/$VARIABLE,
 and, when opened, (optionally) receive a signal,
 and format the current state to be displayed
 to the human attempting to debug them.
 .
 This package contains the development files and man-pages for the C++ library.
