=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

VERSION = "$(shell awk '{gsub(/[)(]/, ""); print $$2; exit}' debian/changelog)"
DATE = $(shell awk '/^ --/ {sub(/^0/, "", $$5); print $$6 " " $$5 ", " $$7}' debian/changelog)

export FEBUG_VERSION=$(VERSION)
export FEBUG_DATE=$(DATE)
export EXTRACCAR=$(subst -O2,,$(shell dpkg-buildflags --get CFLAGS))
export EXTRALDAR=$(shell dpkg-buildflags --get LDFLAGS)


override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs $(wildcard TODO) README.md how.png

%:
	dh $@
