## febug 0.1.2+dfsg

=== debian/changelog ===
febug (0.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 0.1.2+dfsg
  * Don't define _FILE_OFFSET_BITS in Makefile,
    since upstream now does so in main.cpp

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Sun, 31 Jan 2021 15:33:46 +0100

febug (0.1.1+dfsg-2) unstable; urgency=medium

  * Fix build on i386 by always defining -D_FILE_OFFSET_BITS=64
    (cf. #981012, thanks, GCS!)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 25 Jan 2021 18:41:13 +0100
