## febug 0.2.0+dfsg

=== Makefile ===
--- 
+++ 
@@ -9,15 +9,21 @@
 CARGO ?= cargo
 LTO ?= y
 FEBUG_VERSION ?= "$(patsubst v%,%,$(shell git describe))"
-FEBUG_DATE ?= $(shell date $(shell date --version > /dev/null 2>&1 && echo "--date @" || echo "-r ")$(shell git log -1 --no-show-signature --format=%at) +"%B %d, %Y")
+FEBUG_DATE ?= $(shell date $(shell date --version > /dev/null 2>&1 && echo "--date @" || echo "-r ")$(shell git log -1 --no-show-signature --format=%at) +"%B %e, %Y")
 EXTRACCAR ?=
 EXTRALDAR ?=
 
+AS_NEEDED := -Wl,--as-needed
+SONAME := -soname
 SYSTEM := $(shell uname -s)
 ifeq "$(SYSTEM)" "NetBSD"
 	FUSE_ARGS ?= -lrefuse
 else ifeq "$(SYSTEM)" "OpenBSD"
 	FUSE_ARGS ?= -lfuse
+else ifeq "$(SYSTEM)" "Darwin"
+	FUSE_ARGS ?= -lfuse
+	AS_NEEDED :=
+	SONAME := -install_name
 else
 	FUSE_ARGS ?= $(shell pkg-config --libs --cflags fuse3)
 endif
@@ -26,6 +32,10 @@
 ifneq "$(findstring clang,$(CXXVER))" ""
 	# GCC doesn't have this granularity
 	CXXSPECIFICCC := -Wpedantic -Wno-c++20-designator -Wno-c99-extensions -Wno-unknown-warning-option
+ifneq "$(findstring Apple,$(CXXVER))" ""
+	# CMSG_SPACE() is a macro, and it's decidedly constexpr. i don't care if appleclang can't figure that out
+	CXXSPECIFICCC += -Wno-vla-extension
+endif
 	ifeq "$(LTO)" "y"
 		CXXSPECIFICLD := -flto=full  # Clang produces .o files with LLVM bitcode, which cannot be linked to if put in .as
 	else
@@ -43,7 +53,7 @@
 OUTDIR ?= out/
 OBJDIR ?= $(OUTDIR)obj/
 CCAR := -g -O3 -pipe -Wall -Wextra -isysteminclude/ $(CXXSPECIFICCC) $(EXTRACCAR)
-LDAR := -Wl,--as-needed -L$(OUTDIR) $(CXXSPECIFICLD) $(EXTRALDAR)
+LDAR := $(AS_NEEDED) -L$(OUTDIR) $(CXXSPECIFICLD) $(EXTRALDAR)
 HEADERS := $(wildcard include/*.h include/*.hpp)
 EXAMPLES := $(wildcard examples/*.c examples/*.cpp)
 EXAMPLES_RS := $(wildcard examples/*.rs)
@@ -53,9 +63,9 @@
 FUSE_ARGS := $(FUSE_ARGS)
 
 
-.PHONY : main libfebug++ libfebug examples manpages rust-build rust-doc
+.PHONY : main libfebug++ libfebug examples manpages htmlpages rust-build rust-doc
 
-all : main libfebug++ libfebug examples manpages how.png
+all : main libfebug++ libfebug examples manpages htmlpages how.png
 clean:
 	rm -rf $(OUTDIR) $(OBJDIR) how.png
 
@@ -64,6 +74,7 @@
 libfebug : $(OUTDIR)libfebug.a $(OUTDIR)libfebug.so
 examples : $(foreach l,$(patsubst %.c,$(OUTDIR)%,$(patsubst %pp,%,$(EXAMPLES))),$(l) $(l)-dont)
 manpages : $(patsubst %,$(OUTDIR)%,$(MANPAGES)) $(OBJDIR)man/aliases
+htmlpages : $(patsubst %,$(OUTDIR)%.html,$(MANPAGES)) $(OUTDIR)man/style.css
 rust-build : $(OUTDIR)febug.rs/target/libfebug.rlib
 rust-doc : $(OUTDIR)febug.rs/doc/febug/index.html
 
@@ -92,7 +103,7 @@
 
 $(OUTDIR)libfebug.so : $(OBJDIR)febug.o
 	@mkdir -p $(dir $@)
-	$(CC) -shared $< -o$(OUTDIR)libfebug.so.0 -std=c11 -fPIC $(CCAR) $(LDAR) -Wl,-soname,libfebug.so.0
+	$(CC) -shared $< -o$(OUTDIR)libfebug.so.0 -std=c11 -fPIC $(CCAR) $(LDAR) -Wl,$(SONAME),libfebug.so.0
 	ln -fs libfebug.so.0 $@
 
 
@@ -118,20 +129,21 @@
 	@touch $@
 	$(AWK) '!/^$$/ {print "ln -fs " $$1 " $(OUTDIR)man/" $$2}' man/aliases | sh -x
 
-LP := (
-RP := )
-$(OUTDIR)man/% : man/% man/style.css $(wildcard man/*.h)
-	@mkdir -p $(dir $@) $(dir $(OBJDIR)$<)
-	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<)) | \
-		grep -v '^$$' | \
-		(cd $(dir $<); $(AWK) '$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\\\", line); print line}; next}  {print}') \
-		> $(OBJDIR)$<
-	$(MANDOC) -Tman $(OBJDIR)$< > $@
-	$(MANDOC) -Thtml -Oincludes="https://git.sr.ht/~nabijaczleweli/febug/tree/trunk/item/include/%I" $(OBJDIR)$< | \
-		$(AWK) '/<\/style>/ {print "<style>"; while(getline < "man/style.css") print; $$0 = "</style>"; print} /<style>/,/<\/style>/ {next}  {print}' | \
-		sed -re 's/ title=".."//g' $(foreach l,$(subst man/,,$(MANPAGES)), -e 's;(<a class="Xr")>($(subst +,\+,$(subst \$(LP)rs,.rs,$(subst .,\$(LP),$(l))\$(RP))))</a>;\1 href="$(l).html">\2</a>;') > $@.html
-# $(MANDOC) -Tlint $(OBJDIR)$<
+$(OUTDIR)man/% : man/% $(wildcard man/*.h)
+	@mkdir -p $(dir $@)
+	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<) | \
+		$(AWK) '/^$$/ {next}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  \
+			$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\e", line); print line}; next}  \
+			{print}') > $@
+	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'WARNING: unknown manual section: Dt .* 0$$' -e 'STYLE: operating system explicitly specified: Os febug' -e 'STYLE: input text line longer than 80 bytes' -e 'STYLE: .*OpenBSD' -e 'STYLE: RCS id missing'
 
+$(OUTDIR)man/%.html : $(OUTDIR)man/%
+	(cd man/; $(MANDOC) -Thtml -Oincludes="https://git.sr.ht/~nabijaczleweli/febug/tree/trunk/item/include/%I",man="%N.%S.html;https://manpages.debian.org/bullseye/%N.%S",style="style.css" ../$^ | \
+		sed -Ee 's/ title=".."//g') > $@
+
+$(OUTDIR)man/style.css : man/style.css
+	@mkdir -p $(dir $@)
+	ln -f $^ $@ 2>/dev/null || cp $^ $@
 
 $(OUTDIR)febug.rs/README.md : README.md
 	@mkdir -p $(dir $@)
@@ -157,7 +169,7 @@
 
 $(OUTDIR)febug.rs/Cargo.toml : febug.rs/Cargo.toml
 	@mkdir -p $(dir $@)
-	sed -e 's;FEBUG_VERSION;$(FEBUG_VERSION);' $< > $@
+	sed 's;FEBUG_VERSION;$(FEBUG_VERSION);' $< > $@
 
 
 how.png : how.dot
