=== debian/changelog ===
febug (0.2.0+dfsg-1) unstable; urgency=medium

  * Fix uscan filenamemangle
  * New upstream version 0.2.0+dfsg
  * Update upstream changelog
  * Drop now-superfluous mandoc dependency
  * Use a single long date from d/changelog
  * Fix libfebug.rs.3 install location (it's not libfebug.3 translated into rs!)
  * Install systemd units (off by default)

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Thu, 09 Dec 2021 12:05:10 +0100
