=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
 Build-Depends: debhelper,
                debhelper-compat (= 13),
                pkg-config,
-               mandoc,
                graphviz,
                libfuse3-dev,
