=== debian/rules ===
#!/usr/bin/make -f


include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

VERSION = "$(shell awk '{gsub(/[)(]/, ""); print $$2; exit}' debian/changelog)"
DATE = $(shell awk '/^ --/ {sub(/^0/, "", $$5); print $$6 " " $$5 ", " $$7; exit}' debian/changelog | sed -E 's/Jan/&uary/;s/Feb/&ruary/;s/Mar/&ch/;s/Apr/&il/;s/Jun/&e/;s/Jul/&y/;s/Aug/&ust/;s/Sep/&tember/;s/Oct/&ober/;s/Nov|Dec/&ember/')

export FEBUG_VERSION=$(VERSION)
export FEBUG_DATE=$(DATE)
export EXTRACCAR=$(subst -O2,,$(shell dpkg-buildflags --get CFLAGS))
export EXTRALDAR=$(shell dpkg-buildflags --get LDFLAGS)
export MANDOC=true


override_dh_installsystemd:
	dh_installsystemd --no-enable --no-start

override_dh_installsystemduser:
	dh_installsystemduser --no-enable

override_dh_installchangelogs:
	dh_installchangelogs debian/changelog.upstream

override_dh_installdocs:
	dh_installdocs $(wildcard TODO) README.md how.png

override_dh_installman:
	dh_installman --language=C

%:
	dh $@
