## febug 0.2.1+dfsg

=== Makefile ===
--- 
+++ 
@@ -134,7 +134,7 @@
 	(cd $(dir $<); $(CPP) -nostdinc -Wno-trigraphs -Wno-invalid-pp-token -CC -P -DFEBUG_DATE="$(FEBUG_DATE)" -DFEBUG_VERSION='$(FEBUG_VERSION)' - < $(notdir $<) | \
 		$(AWK) '/^$$/ {next}  $$1 == ".Dt" { print ".ds doc-volume-operating-system" }  \
 			$$1 == "$$include" {gsub(/"/, "", $$2); while((getline line < $$2) > 0) {gsub(/\\/, "\\e", line); print line}; next}  \
-			{print}') > $@
+			{sub(/^~/, "\\(ti"); gsub(/([^\\])~/, "&_BUT-TI_"); gsub(/~_BUT-TI_/, "\\(ti"); print}') > $@
 	! $(MANDOC) -Tlint $@ 2>&1 | grep -vE -e 'mandoc: outdated mandoc.db' -e 'STYLE: referenced manual not found' -e 'WARNING: unknown manual section: Dt .* 0$$' -e 'STYLE: operating system explicitly specified: Os febug' -e 'STYLE: input text line longer than 80 bytes' -e 'STYLE: .*OpenBSD' -e 'STYLE: RCS id missing'
 
 $(OUTDIR)man/%.html : $(OUTDIR)man/%
