=== debian/changelog ===
febug (0.2.1+dfsg-1) unstable; urgency=medium

  * New upstream version 0.2.1+dfsg
  * Include headers properly in -dev packages
  * libfebug++-dev Depends: libfebug-dev
  * Update upstream changelog

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Mon, 12 Jun 2023 17:50:08 +0200
