=== debian/control ===
--- 
+++ 
@@ -60,7 +60,8 @@
 Package: libfebug++-dev
 Recommends: febug
 Architecture: any
-Depends: ${misc:Depends},
+Depends: libfebug-dev,
+         ${misc:Depends},
          ${shlibs:Depends},
 Tag: implemented-in::c, role::library
 Description: Cooperative debugging filesystem, inspired by debugfs -- C++ development files
