=== debian/changelog ===
febug (1.0.0+dfsg-1) unstable; urgency=medium

  * Build-Depends: pkg-config -> pkgconf
  * d/upstream/signing-key.asc, d/watch: pull and verify signature
  * New upstream version 1.0.0+dfsg (+ changelog & NEWS)
  * d/upstream/metadata: add
  * d/copyright & d/rules: update for 1.0.0
  * Add python3-febug package
  * Don't strip libfebug++.a
  * libfebug-dev Depends: libfebug0

 -- наб <nabijaczleweli@nabijaczleweli.xyz>  Fri, 08 Dec 2023 23:49:55 +0100
