=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Homepage: https://sr.ht/~nabijaczleweli/febug
 Build-Depends: debhelper,
                debhelper-compat (= 13),
-               pkg-config,
+               pkgconf,
                graphviz,
                libfuse3-dev,
 
@@ -47,6 +47,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
+         libfebug0
 Tag: implemented-in::c, role::library
 Description: Cooperative debugging filesystem, inspired by debugfs -- C development files
  Applications can register variables to be observable,
@@ -55,7 +56,7 @@
  and format the current state to be displayed
  to the human attempting to debug them.
  .
- This package contains the development files and man-pages for the C library.
+ This package contains the development files and manuals for the C library.
 
 Package: libfebug++-dev
 Recommends: febug
@@ -63,7 +64,7 @@
 Depends: libfebug-dev,
          ${misc:Depends},
          ${shlibs:Depends},
-Tag: implemented-in::c, role::library
+Tag: implemented-in::c++, role::library
 Description: Cooperative debugging filesystem, inspired by debugfs -- C++ development files
  Applications can register variables to be observable,
  showing up as files in /var/run/febug/$PID/$VARIABLE,
@@ -71,4 +72,20 @@
  and format the current state to be displayed
  to the human attempting to debug them.
  .
- This package contains the development files and man-pages for the C++ library.
+ This package contains the development files and manuals for the C++ library.
+
+Package: python3-febug
+Recommends: febug
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+         python3:any
+Tag: implemented-in::python, role::library
+Description: Cooperative debugging filesystem, inspired by debugfs -- Python 3 library
+ Applications can register variables to be observable,
+ showing up as files in /var/run/febug/$PID/$VARIABLE,
+ and, when opened, (optionally) receive a signal,
+ and format the current state to be displayed
+ to the human attempting to debug them.
+ .
+ This package contains the Python 3 library and manuals therefor.
