=== debian/watch ===
version=4
opts="filenamemangle=s/v?(\d\S+)\.tar\.gz/febug-$1\.tar\.gz/,\
dversionmangle=s/\+dfsg//,repacksuffix=+dfsg,\
pgpsigurlmangle=s/$/.asc/" \
  https://git.sr.ht/~nabijaczleweli/febug/refs .*/v?(\d\S+)\.tar\.gz
